<?php
	// 20090518 - Remove Start, add Premium
	// version control
	if (substr_count(strtolower($version), "standard") > 0 || substr_count(strtolower($version), 'premium') > 0) {
		if (substr_count(strtolower($version), 'premium') > 0) {
			$disabled = '';
			$version_star = '';
			$disabled_prm = ' disabled';
			$version_star_prm = '<span class="star">* </span>';
		} else {
			$disabled = ' disabled';
			$version_star = '<span class="star">* </span>';
			$disabled_prm = '';
			$version_star_prm = '';
		}
        if (substr_count(strtolower($version),"donation")>0)
            $version = substr($version,0,strlen($version)-9);
        $version_msg = '* This feature is not available in '. ucwords($version) .' Edition.';
    } else {
        $disabled = '';
        $version_msg = '';
        $version_star = '';
		$disabled_prm = '';
		$version_star_prm = '';
    }

    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

    echo '<script type="text/javascript" src="./javascript/dispatcher.js"></script>'."\n";
    echo '<form action="settingok.php" name="form_d" method="post" onSubmit="return validate_d()">'."\n";

    gen_head();
    gen_license_warning($version_msg);

    $value=$settingobj->getKey('port', 'gateway');
    $input='<input class="longtextbox" type="text" name="port" maxlength="5" value="'.$value.'" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_line(get_cm_var('setcfg_dispatcher_service_listen_port'), $input);

    gen_sep();

    $value=$settingobj->getKey('idle_timeout', 'gateway');
    $input='<input class="longtextbox" type="text" name="idle_timeout" maxlength="5" value="'.$value.'" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_line(get_cm_var('setcfg_dispatcher_idle_timeout'), $input);

    gen_sep();

    $value=$settingobj->getKey('sessionlimit', 'gateway');
    $input='<input class="longtextbox" type="text" name="sessionlimit" maxlength="5" value="'.$value.'" '.$disabled.' onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_line($version_star.get_cm_var('setcfg_dispatcher_session_timelimit'), $input);
    
    gen_sep();
    
    $value=$settingobj->getKey('max_conc_user', 'gateway');
    $input='<input class="longtextbox" type="text" name="max_conc_user" maxlength="5" value="'.$value.'" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_line(get_cm_var('setcfg_dispatcher_concurrent_userlimit'), $input);

    gen_sep();
    gen_sep();

    $gateway_IP=$settingobj->getKey('gateway_IP', 'gateway');
    $gateway_fields=split("\.", $gateway_IP);
    $i=0; $input='';
    while ($i<3) {
        $input .= '<input class="IPtextbox" type="text" name="gateway_IP'.$i.'" value='.$gateway_fields[$i]." maxlength=\"3\" onKeyPress=\"return numbersonly(this,event,'gateway_IP".($i+1)."')\" onfocus=\"this.select()\">. ";
        $i++;
    }
    $input .= '<input class="IPtextbox" type="text" name="gateway_IP'.$i.'" value='.$gateway_fields[$i].' maxlength="3" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';

    gen_line(get_cm_var('setcfg_dispatcher_private_interface_IP'), $input);

    gen_sep();

    $subnet_mask=$settingobj->getKey('subnet_mask', 'gateway');
    $subnet_fields=split("\.", $subnet_mask);
    $i=0; $input='';

	// 20090612 - Fix maxmimum size at class B
	while ($i < 2) {
		if ($subnet_fields[$i] != '255') {
			$subnet_fields[$i] = '255';
		}
		$input .= '<input type="hidden" name="subnet_mask'.$i.'" value='.$subnet_fields[$i].'>'.$subnet_fields[$i].' . ';
		$i++;
	}

    while ($i<3) {
        $input .= '<input class="IPtextbox" type="text" name="subnet_mask'.$i.'" value='.$subnet_fields[$i]." maxlength=\"3\" onKeyPress=\"return numbersonly(this,event,'subnet_mask".($i+1)."')\" onfocus=\"this.select()\">. ";
        $i++;
    } 
    $input .= '<input class="IPtextbox" type="text" name="subnet_mask'.$i.'" value='.$subnet_fields[$i].' maxlength="3" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';

    gen_line(get_cm_var('setcfg_dispatcher_subnet_mask'), $input);

    gen_sep();

    if($settingobj->getKey('netbios', 'gateway')=='0'){
        $input = '<input type="radio" '.$disabled.' name="netbios" value="0" checked>Enabled
            <input type="radio" '.$disabled.' name="netbios" value="1" >Disabled<br>'; 
    } else {
        $input = '<input type="radio" '.$disabled.' name="netbios" value="0">Enabled
            <input type="radio" '.$disabled.' name="netbios" value="1" checked>Disabled<br>';
    }
    gen_line($version_star.get_cm_var('setcfg_dispatcher_client_isolation'), $input);

    gen_sep();

    
    
    gen_line(get_cm_var('setcfg_dispatcher_public_interface_IP'), get_cm_var('setcfg_dispatcher_public_interface_IP_remainer'));
    
    /*
    // [sphl] 20070216 - moved to Instant keywords       
    $dns_suffix=$settingobj->getKey('dns_suffix', 'gateway');
    //maxlength="5"
    $input='<input class="longtextbox" type="text" name="dns_suffix" value="'.$dns_suffix.'">';
    gen_line(get_cm_var('setcfg_dispatcher_dns_suffix'), $input);
    gen_sep();
	*/	

    gen_sep();
    gen_sep();

    // bandwidth throttle settings (overall)
    $bt_mode=$settingobj->getKey('bt_mode', 'bw_throttle');  

    if($bt_mode<0||$bt_mode>4)
        $bt_mode=0;

    // initialization
    for($i=0;$i<=4;$i++) {
        $var="checkedStr$i";
        $$var='';
    }

    $var_c="checkedStr$bt_mode";
    $$var_c='checked';

    $bt_num=$settingobj->getKey('bt_ul_limit', 'bw_throttle');
    $bt_num_down=$settingobj->getKey( 'bt_dl_limit', 'bw_throttle');

    if($bt_mode==0) {
        $bt_num = '';
        $bt_num_down = '';
    }

    if($bt_mode==4) {
        $disable = '';
    } else {
        $disable = ' disabled';
    }

    $input = '<input type="radio" name="bt_mode" value="4" '.$checkedStr4.' onclick="enable_textbox()">&nbsp;&nbsp;&nbsp;&nbsp;
        Upload: <input type="text" name="bt_num" maxlength="10" value="'. $bt_num .'" '.$disable.' class="shorttextbox" style="width:100px;" onKeyPress="return numbersonly(this,event)"><br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        Download: <input type="text" name="bt_num_down" maxlength="10" value="'. $bt_num_down .'" '.$disable.' class="shorttextbox" style="width:100px;" onKeyPress="return numbersonly(this,event)"><br>
        <input type="radio" name="bt_mode" value="1" '.$checkedStr1.' onclick="disable_textbox()">Low (~'.$bt_num_low.' KBytes/s)<br>
        <input type="radio" name="bt_mode" value="2" '.$checkedStr2.' onclick="disable_textbox()">Medium (~'.$bt_num_medium.' KBytes/s)<br>
        <input type="radio" name="bt_mode" value="3" '.$checkedStr3.' onclick="disable_textbox()">High (~'.$bt_num_high.' KBytes/s)<br>
        <input type="radio" name="bt_mode" value="0" '.$checkedStr0.' onclick="disable_textbox()">No throttling<br>';

    gen_line(get_cm_var('setcfg_dispatcher_bt'), $input);

    //****************************************************************************************************
    // QoS
    //****************************************************************************************************
    gen_sep();

    // purge if cancel
    if (isset($purge)&&($purge=='true')) {
        $ser_display_qos=NULL;
        $ser_add_qos=NULL;
    }

    if($settingobj->getKey('qos_num', 'QOS') > 0) {
        $diableqos = '';
        $displayQos= '';
        $input='<input type="radio" name="qos" value="on"  onclick="showQOS()" '.$disabled.$disabled_prm.' checked>'.get_cm_var('setcfg_dispatcher_enabled').'
            <input type="radio" name="qos" value="off" onclick="showQOS()" '.$disabled.$disabled_prm.'>'.get_cm_var('setcfg_dispatcher_disabled');
    } else {
        $diableqos = 'disabled';
        $displayQos= 'none';
        $input='<input type="radio" name="qos" value="on" onclick="showQOS()" '.$disabled.$disabled_prm.'>'.get_cm_var('setcfg_dispatcher_enabled').'
            <input type="radio" name="qos" value="off"  onclick="showQOS()" checked '.$disabled.$disabled_prm.'>'.get_cm_var('setcfg_dispatcher_disabled');
    }
    gen_line($version_star.$version_star_prm.get_cm_var('setcfg_dispatcher_qos'),$input);

    // 20080930 - Add bandwidth list box
    $input = '
	'.get_cm_var('setcfg_dispatcher_qos_bw_text').'<br>
	<select name="qos_bw_type" style="width:230px; font-family:sans-serif,Tahoma; font-size:9pt;" onchange=OnSelectQOSBw(this)>
	    <option value=0>'.get_cm_var('setcfg_dispatcher_qos_opt_0').'</option>
	    <option value=1>'.get_cm_var('setcfg_dispatcher_qos_opt_1').'</option>
	    <option value=2>'.get_cm_var('setcfg_dispatcher_qos_opt_2').'</option>
	    <option value=3>'.get_cm_var('setcfg_dispatcher_qos_opt_3').'</option>
	    <option value=4>'.get_cm_var('setcfg_dispatcher_qos_opt_4').'</option>
	    <option value=5>'.get_cm_var('setcfg_dispatcher_qos_opt_5').'</option>
	    <option value=6>'.get_cm_var('setcfg_dispatcher_qos_opt_6').'</option>
	    <option value=7>'.get_cm_var('setcfg_dispatcher_qos_opt_7').'</option>
	</select><br>
	'.get_cm_var('setcfg_dispatcher_qos_or_text').'<br>';
    gen_invisible_line2('', $input, 'divQos3', $displayQos);

    $dl = $settingobj->getKey('dl', 'QOS');
    $ul = $settingobj->getKey('ul', 'QOS');

    $input='Download Speed&nbsp;(KB/s) <br><input class="longtextbox" '.$disabled.$disabled_prm.' type="text" name="qos_dl" maxlength="15" value="'.$dl.'" style="width:140px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_invisible_line2('',$input,'divQos0',$displayQos);

    $input='Upload Speed&nbsp;(KB/s) <br><input class="longtextbox" '.$disabled.$disabled_prm.' type="text" name="qos_ul" maxlength="15" value="'.$ul.'"  style="width:140px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">';
    gen_invisible_line2('',$input,'divQos1',$displayQos);

    $frame='setqos.php';

    // 20081223 - Adjust frame size
    echo '
            <tr id="divQos2" align="center" style="display: '.$displayQos.';">
                <td width="100%" colspan="4" align="center">
                    <iframe id="loadframe_qos" name="loadframe_qos" frameborder="0" width="500" height="400" src="'.$frame.'" marginwidth="0" marginheight="0" scrolling="no"></iframe>
                </td>
            </tr>'."\n";


    gen_sep();
    gen_sep();

    //****************************************************************************************************
    // Global data transfer setting
    //****************************************************************************************************
    $bwcount_dl = $settingobj->getKey('bwcount_dl', 'DataTransfer');
    $bwcount_ul = $settingobj->getKey('bwcount_ul', 'DataTransfer');

    $bwdl_quota_value = '';
    $bwul_quota_value = '';
    if( $bwcount_dl>0 ) {
        $bwdl_off_checked = '';
        $bwdl_on_checked = 'checked';
        $showQuotaDL = '';
        if( $bwcount_dl == 2 ) {
            $bwdl_quota_checkbox_checked = 'checked';
            $bwdl_quota_disable = '';
            $bwdl_quota_value = $settingobj->getKey('bwquota_dl', 'DataTransfer');
        } else {
            $bwdl_quota_checkbox_checked = '';
            $bwdl_quota_disable = 'disabled';
            $bwdl_quota_value = '';
        }
    } else {
        $bwdl_quota_checkbox_checked = '';
        $bwdl_off_checked = 'checked';
        $bwdl_on_checked = '';
        $showQuotaDL = 'none';
        $bwdl_quota_disable = 'disabled';
    }

    if( $bwcount_ul>0 ) {
        $bwul_off_checked = '';
        $bwul_on_checked = 'checked';
        $showQuotaUL = '';
        if( $bwcount_ul == 2 ) {
            $bwul_quota_checkbox_checked = 'checked';
            $bwul_quota_disable = '';
            $bwul_quota_value = $settingobj->getKey('bwquota_ul', 'DataTransfer');
        } else {
            $bwul_quota_checkbox_checked = '';
            $bwul_quota_disable = 'disabled';
            $bwul_quota_value = '';
        }
    } else {
        $bwul_quota_checkbox_checked = '';
        $bwul_off_checked = 'checked';
        $bwul_on_checked = '';
        $showQuotaUL = 'none';
        $bwul_quota_disable = 'disabled';
    }

    $input='<input type="radio" name="bw_setting_dl" value="1" '.$bwdl_on_checked.' onclick="ShowQuotaDL();">'.get_cm_var('setcfg_dispatcher_enabled').'<input type="radio" name="bw_setting_dl" value="0" '.$bwdl_off_checked.' onclick="HideQuotaDL();">'.get_cm_var('setcfg_dispatcher_disabled').'<br>
                <div id="div_dispatch_quota_dl" style="display: '.$showQuotaDL.';">
                    <input type="checkbox" name="bwdl_quota_checkbox" '.$bwdl_quota_checkbox_checked.' value="EnableQuotaDL" onClick="EnableQuotaDL();">'.get_cm_var('setcfg_dispatcher_bw_quota').'
                    <input class="shorttextbox" type="textbox" name="bwdl_quota" maxlength="10" value="'.$bwdl_quota_value.'" '.$bwdl_quota_disable.' onKeyPress="return numbersonly(this,event)" onfocus="this.select()"> '.get_cm_var('setcfg_dispatcher_bw_KB').'
                </div>';

    gen_line(get_cm_var('setcfg_dispatcher_bwdl'), $input);

    gen_sep();

    $input='<input type="radio" name="bw_setting_ul" value="1" '.$bwul_on_checked.' onclick="ShowQuotaUL();">'.get_cm_var('setcfg_dispatcher_enabled').'<input type="radio" name="bw_setting_ul" value="0" '.$bwul_off_checked.' onclick="HideQuotaUL();">'.get_cm_var('setcfg_dispatcher_disabled').'<br>

            <div id="div_dispatch_quota_ul" style="display: '.$showQuotaUL.'">
                <input type="checkbox" name="bwul_quota_checkbox" '.$bwul_quota_checkbox_checked.' value="EnableQuotaUL" onClick="EnableQuotaUL();">'.get_cm_var('setcfg_dispatcher_bw_quota').'
                <input class="shorttextbox" type="textbox" name="bwul_quota" maxlength="10" value="'.$bwul_quota_value.'" '.$bwul_quota_disable.' onKeyPress="return numbersonly(this,event)" onfocus="this.select()"> '.get_cm_var('setcfg_dispatcher_bw_KB').'
            </div>';

    gen_line(get_cm_var('setcfg_dispatcher_bwul'), $input);

    gen_sep();
    //****************************************************************************************************
    // End - Global data transfer setting
    //****************************************************************************************************

    //****************************************************************************************************
    // Global accumulative data transfer reset setting
    //****************************************************************************************************
    $abw_rmChecked0 = '';
    $abw_rmChecked1 = '';
    $abw_rmChecked2 = '';
    $rp_abw_method = '';
    $rp_abw_period = '';
    $abw_rdate = '';
    $abw_rd_disabled = 'disabled';
    $abw_rp_disabled = 'disabled';
    $abw_mday = '';
    $rp_abw_method=$settingobj->getKey('bwresetmethod', 'bwreset');
    $rp_abw_period=$settingobj->getKey('bwresetperiod', 'bwreset');
    $timeArray_date = '';
    $timeArray_time = '';
    $rp_abw_lastrbw=$settingobj->getKey('lastresetbw', 'bwreset');
    if ($rp_abw_lastrbw > 0){
			$timeArray = getdate($rp_abw_lastrbw);
			$mon =($timeArray['mon'] < 10) ? "0".$timeArray['mon'] : $timeArray['mon'];
			$mday = ($timeArray['mday'] < 10) ? "0".$timeArray['mday'] : $timeArray['mday'] ;
			$hours = ($timeArray['hours'] < 10) ? "0".$timeArray['hours'] : $timeArray['hours'] ;
			$minutes = ($timeArray['minutes'] < 10) ? "0".$timeArray['minutes'] : $timeArray['minutes'] ;
			$timeArray_date = $mon."-".$mday."-".$timeArray['year'];
			$timeArray_time = $hours.":".$minutes;//.":".$timeArray['seconds'];
		}
    $rp_abw_date=$settingobj->getKey('bwresetdate', 'bwreset');
    if($rp_abw_method=='month') {
        $abw_rmChecked1 = 'checked';
        $abw_monthly_default = '';
        $abw_daily_default = 'none';
        $abw_lastrbw_default = '';
    } else if($rp_abw_method=='day') {
        $abw_rmChecked2 = 'checked';
        $abw_monthly_default = 'none';
        $abw_daily_default = '';
        $abw_lastrbw_default = '';
    } else {
        $abw_rmChecked0 = 'checked';
        $abw_monthly_default = 'none';
        $abw_daily_default = 'none';
        $abw_lastrbw_default = 'none';
    }
    $input = '<input type="radio" name="abw_rm" value="0" '.$abw_rmChecked0.' onclick="abw_disable_all()">'.get_cm_var('setcfg_dispatcher_resetabw_disabled').'
        <input type="radio" name="abw_rm" value="1" '.$abw_rmChecked1.' onclick="abw_enable_textbox()">'.get_cm_var('setcfg_dispatcher_resetabw_monthly').'
        <input type="radio" name="abw_rm" value="2" '.$abw_rmChecked2.' onclick="abw_disable_textbox()">'.get_cm_var('setcfg_dispatcher_resetabw_daily');
    gen_line(get_cm_var('setcfg_dispatcher_reset_period'), $input);

    $input = '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.get_cm_var('setcfg_dispatcher_resetabw_monthly_str1').
            '<input type="text" maxlength="2" name="abw_rdate" value="'.$rp_abw_date.'" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_dispatcher_resetabw_monthly_str2').
            '<input type="text" maxlength="2" name="abw_rp_1" value="'.$rp_abw_period.'" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_dispatcher_resetabw_monthly_str3').'<br><br>';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_resetabw_title'),$input,'abw_monthly',$abw_monthly_default);
    
    $input = '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.get_cm_var('setcfg_dispatcher_resetabw_daily_str1').
            '<input type="text"  maxlength="3" name="abw_rp_2" value="'.$rp_abw_period.'" class="shorttextbox" style="width:30px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.
            get_cm_var('setcfg_dispatcher_resetabw_daily_str2').'<br><br>';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_resetabw_title'),$input,'abw_daily',$abw_daily_default);
    
    //global Set last period of time (Reset ABW)
    
    $input = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('.get_cm_var('setcfg_date_format').')&nbsp;('.get_cm_var('setcfg_time_format').')<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" maxlength="10" name="abw_lastrbw_date" value="'.$timeArray_date.'" class="shorttextbox" style="width:70px;"  onfocus="this.select()"> &nbsp;'.
            '<input type="text" maxlength="5" name="abw_lastrbw_time" value="'.$timeArray_time.'" class="timetextbox" style="width:40px;" onfocus="this.select()">'
            ;
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_resetabw_title2'),$input,'abw_lastrbw',$abw_lastrbw_default);
    
    //gen_line(get_cm_var('setcfg_dispatcher_resetabw_title2'), $input);
    
    //****************************************************************************************************
    // End - Global accumulative data transfer reset setting
    //****************************************************************************************************

    gen_sep();
    gen_sep();

    $value=$settingobj->getKey('batch_filePath', 'gateway');
    $input='<input class="longtextbox" type="text" name="batch_filePath" value="'.$value.'"  onfocus="this.select()">';
    gen_line(get_cm_var('setcfg_dispatcher_location_for_post_startup_file'), $input);

    gen_sep();
    gen_sep();

    //****************************************************************************************************
    // SMTP setting
    //****************************************************************************************************
    $SMTP_on=$settingobj->getKey('smtp', 'fssmtp');
    $isp_smtp = $settingobj->getKey('IspSmtpDomain', 'fssmtp');
    if( strtolower($SMTP_on) == 'true' && $isp_smtp!='') { // on smtp and and use ISP smtp 
        $defaultSMTPon = '';
        $defaultSMTPoff = 'none';
        $defaultSMTPon_check = ' checked';
        $defaultSMTPoff_check = '';
        
        	$defaultSMTP_isp_on = '';
	        $defaultSMTP_isp_on_check = '';
	        $defaultSMTP_isp_off_check = 'checked';
	        
	        $IspSmtpAuthLogin = $settingobj->getKey('IspSmtpAuthLogin', 'fssmtp');
	        if ($IspSmtpAuthLogin == 'true'){
	       		$defaultSMTP_isp_auth_login_on_check = 'checked';
	        	$defaultSMTP_isp_auth_login_off_check = '';
	        	$defaultSMTP_isp_auth_login = '';
        	} else {
	        	$defaultSMTP_isp_auth_login_on_check = '';
	        	$defaultSMTP_isp_auth_login_off_check = 'checked';
	        	$defaultSMTP_isp_auth_login = 'none';
        	}

		/*$isp_smtp = $settingobj->getKey('IspSmtpDomain', 'fssmtp');
		if ($isp_smtp==''){ // use firstspot smtp
			$defaultSMTP_isp_on = 'none';
	        $defaultSMTP_isp_on_check = 'checked';
	        $defaultSMTP_isp_off_check = '';
	        $defaultSMTP_isp_on = 'none';
	        $defaultSMTP_isp_auth_login_on_check = '';
	      	$defaultSMTP_isp_auth_login_off_check = 'checked';
        	$defaultSMTP_isp_auth_login = 'none';
		} else {
			$defaultSMTP_isp_on = '';
	        $defaultSMTP_isp_on_check = '';
	        $defaultSMTP_isp_off_check = 'checked';
	        
	        $IspSmtpAuthLogin = $settingobj->getKey('IspSmtpAuthLogin', 'fssmtp');
	        if ($IspSmtpAuthLogin == 'true'){
	       		$defaultSMTP_isp_auth_login_on_check = 'checked';
	        	$defaultSMTP_isp_auth_login_off_check = '';
	        	$defaultSMTP_isp_auth_login = '';
        	} else {
	        	$defaultSMTP_isp_auth_login_on_check = '';
	        	$defaultSMTP_isp_auth_login_off_check = 'checked';
	        	$defaultSMTP_isp_auth_login = 'none';
        	}
	        
		}*/
    } else { // off smtp
        $defaultSMTPon = 'none';
        $defaultSMTPoff = '';
        $defaultSMTPon_check = '';
        $defaultSMTPoff_check = ' checked';
		$defaultSMTP_isp_on = 'none';
        $defaultSMTP_isp_on_check = 'checked';
        $defaultSMTP_isp_off_check = '';
        $defaultSMTP_isp_auth_login_on_check = '';
	      $defaultSMTP_isp_auth_login_off_check = 'checked';
        $defaultSMTP_isp_auth_login = 'none';
    }

    // SMTP ON/OFF SELECTION
    $input= '<input type="radio" '.$disabled.' name="smtp_on_selection" value="smtp_on"'.$defaultSMTPon_check.'>'.get_cm_var('setcfg_dispatcher_enabled').'&nbsp;<input type="radio" '.$disabled.' name="smtp_on_selection" value="smtp_off"'.$defaultSMTPoff_check.' onClick="smtpOff()">'.get_cm_var('setcfg_dispatcher_disabled');
    gen_invisible_line($version_star.get_cm_var('setcfg_dispatcher_smtp_selection'), $input, 'smtp_on_checked', $defaultSMTPon);

    $input= '<input type="radio" '.$disabled.' name="smtp_off_selection" value="smtp_on"'.$defaultSMTPon_check.' onClick="smtpOn()">'.get_cm_var('setcfg_dispatcher_enabled').'&nbsp;<input type="radio" '.$disabled.' name="smtp_off_selection" value="smtp_off"'.$defaultSMTPoff_check.'>'.get_cm_var('setcfg_dispatcher_disabled');
    gen_invisible_line($version_star.get_cm_var('setcfg_dispatcher_smtp_selection'), $input, 'smtp_off_checked', $defaultSMTPoff);

    gen_invisible_sep('smtp_line1', $defaultSMTPon);
/*	
	// ISP SMTP ON/OFF SELECTION
    $input= '<input type="radio" '.$disabled.' name="smtp_isp_on_selection" value="smtp_isp_on"'.$defaultSMTP_isp_on_check.' onClick="ispChangeSMTP()">'.get_cm_var('setcfg_dispatcher_smtp_yes').'&nbsp;<input type="radio" '.$disabled.' name="smtp_isp_on_selection" value="smtp_isp_off"'.$defaultSMTP_isp_off_check.' onClick="ispChangeSMTP()">'.get_cm_var('setcfg_dispatcher_smtp_no');
    gen_invisible_line2($version_star.get_cm_var('setcfg_dispatcher_smtp_ISP_enable'), $input, 'smtp_isp_on_checked', $defaultSMTPon);
	
    gen_invisible_sep('smtp_line2', $defaultSMTPon);
*/
	if (!isset($IspSmtpDomain))
        $IspSmtpDomain = $settingobj->getKey('IspSmtpDomain', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="IspSmtpDomain" value="'.$IspSmtpDomain.'" style="width : 250px" onfocus="this.select()">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_ISP'), $input, 'IspSmtpDomain', $defaultSMTP_isp_on);
    gen_invisible_sep('smtp_line3', $defaultSMTP_isp_on);
    
  //authentication login
    $input= '<input type="radio" '.$disabled.' name="IspSmtpAuthLogin" value="true"'.$defaultSMTP_isp_auth_login_on_check.' onClick="ispChangeAuthLogin()">'.get_cm_var('setcfg_dispatcher_smtp_yes').'&nbsp;<input type="radio" '.$disabled.' name="IspSmtpAuthLogin" value="false"'.$defaultSMTP_isp_auth_login_off_check.' onClick="ispChangeAuthLogin()">'.get_cm_var('setcfg_dispatcher_smtp_no');
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_ISP_auth_login'), $input, 'IspSmtpAuthLogin', $defaultSMTP_isp_on);
	
    gen_invisible_sep('smtp_line3a', $defaultSMTP_isp_on);
    
    if (!isset($IspSmtpUserName))
        $IspSmtpUserName = $settingobj->getKey('IspSmtpUserName', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="IspSmtpUserName" value="'.$IspSmtpUserName.'" style="width : 250px" onfocus="this.select()">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_ISP_user_name'), $input, 'IspSmtpUserName', $defaultSMTP_isp_auth_login);
    gen_invisible_sep('smtp_line3b', $defaultSMTP_isp_auth_login);
    
     if (!isset($IspSmtpPassword))
        $IspSmtpPassword = $settingobj->getKey('IspSmtpPassword', 'fssmtp');
    $input = '<input class="longtextbox" type="password" '.$disabled.' name="IspSmtpPassword" value="'.$IspSmtpPassword.'" style="width : 250px" onfocus="this.select()">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_ISP_password'), $input, 'IspSmtpPassword', $defaultSMTP_isp_auth_login);
    gen_invisible_sep('smtp_line3c', $defaultSMTP_isp_auth_login);
    
     if (!isset($SmtpPort))
        $SmtpPort = $settingobj->getKey('SmtpPort', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="SmtpPort" maxlength="6" value="'.$SmtpPort.'" style="width : 250px" onKeyPress="return numbersonly(this,event)">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_port'), $input, 'SmtpPort', $defaultSMTP_isp_on);
    gen_invisible_sep('smtp_line3d', $defaultSMTP_isp_on);

    // Recipient Limit
    if (!isset($rcptMax))
        $rcptMax = $settingobj->getKey('rcptMax', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="rcptMax" maxlength="10" value="'.$rcptMax.'" style="width : 250px" onKeyPress="return numbersonly(this,event)">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_rcpt'), $input, 'rcptMax', $defaultSMTPon);

    gen_invisible_sep('smtp_line4', $defaultSMTPon);

    // Mail Size Limit
    if (!isset($mailsize))
        $mailsize = $settingobj->getKey( 'mailsize', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="mailsize" maxlength="4" value="'.$mailsize.'" style="width : 250px" onKeyPress="return numbersonly(this,event)">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_mailsize'), $input, 'mailsize', $defaultSMTPon);

    gen_invisible_sep('smtp_line5', $defaultSMTPon);

    // Send Mail Recycle Time
    if (!isset($execTime))
        $execTime = $settingobj->getKey('execTime', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="execTime" maxlength="8" value="'.$execTime.'" style="width : 250px" onKeyPress="return numbersonly(this,event)">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_execTime'), $input, 'execTime', $defaultSMTPon);

    gen_invisible_sep('smtp_line6', $defaultSMTPon);
    /*
    // Switch Log Time Interval
    if (!isset($MailLogOffset))
        $MailLogOffset = $settingobj->getKey('MailLogOffset', 'fssmtp');
    $input = '<input class="longtextbox" type="text" '.$disabled.' name="MailLogOffset" maxlength="8" value="'.$MailLogOffset.'" style="width : 250px" onKeyPress="return numbersonly(this,event)">';
    gen_invisible_line2(get_cm_var('setcfg_dispatcher_smtp_MailLog'), $input, 'MailLogOffset', $defaultSMTPon);*/
    //****************************************************************************************************
    // End - SMTP setting
    //****************************************************************************************************

    gen_sep();

    gen_save('save_d',$fs_status);
    gen_foot();
    // release the COM object
    //$settingobj->Release();
    $settingobj=null;
?>
