<?php

// create a COM object
$myobj = new COM("FSAUTH.Authserv") or die("disconnectscript.php FSAUTH.Authserv object cannot be created!");

// call the 'Logout' method of this object, passes in the 'ip' & 'mac' session parameters
// session $_session['patronsoft1'] is 'ip'; session $_session['patronsoft2'] is 'mac'
if (isset($_SESSION['sess_patronsoft1']) && isset($_SESSION['sess_patronsoft2'])) {
    $rsult = $myobj->Logout($_SESSION['sess_patronsoft1'], $_SESSION['sess_patronsoft2']);
} else if (isset($_SESSION['session_username'])) {
    $rsult = $myobj->ForceLogout($_SESSION['session_username']);
}

$settingobj = new COM("FSCONFIG.Cfgmgr") or die("disconnectscript.php FSCONFIG.Cfgmgr Object cannot be created!");

$show_cart = $settingobj->getKey("show_cart", "misc");

if (isset($rsult)) {
    // error-checking
    if (!$rsult) {
	// 20080403 - Remove HTML layout
	echo '<p><span class="disconnSmallText">disconnectscript.php com_invoke method failed!</span></p>';
    } else {
	// 20080603 - Unregister patronsoft1 also to prevent repeating logout action
	// 20080411 - Unregister username is enough, otherwise info will not display properly at next login
	// 20071106 - Effective unregister method for PHP 5.2
        // unregister sessions
	unset($_SESSION['session_username']);
	unset($_SESSION['sess_patronsoft1']);
    }    
}

// free the COM object
$myobj = null;  
$settingobj = null;  

?>
