<?php
//include_once "htmlclass.php";
function table_new($row) {
		
	$table = '<table width="100%" border="0" cellspacing="0" cellpadding="0">';
	
	//x - row, y - col
	//$row[x][0] - html style class
	//$row[x][y] - field value
	foreach($row as $field) {			
		
		$table .= "<tr class='$field[0]'>";
		for($i=1; $i<count($field); $i++) {
			$table .= "<td>";	
			$table .= "$field[$i]";
			$table .= "</td>";
		}
		$table .= "</tr>";
		
	}

	$table .= '</table>';
	
	return $table;
}

function long2mac($mac_long)
{	
	if($mac_long <0)
		return "";
		
	//dec to hex
	$machex = array();
	$i = 0;
	while($mac_long!=0) {
		$rslt = floor($mac_long/16); 
		$machex[$i] = $mac_long - ($rslt*16);
		$mac_long = $rslt;
		$i++;
	}

	$mac = "";
	for($i=count($machex)-1; $i>=0; $i--) {
		$mac .= dechex($machex[$i]);
	}
	
	//convert hex to 12 digits
	while(strlen($mac)<12) {
		$mac = "0".$mac;
	}
	
	//convert hex to mac format
	if(strlen($mac) == 12) {
		$mac_array = array();
		
		$count = 0;
		for($i=0; $i<12; $i=$i+2) {
			$mac_array[$count] = strtoupper(substr($mac, $i, 2));
			$count++;
		}
			
		$mac = "$mac_array[5]-$mac_array[4]-$mac_array[3]-$mac_array[2]-$mac_array[1]-$mac_array[0]";
		
		return $mac;
	}
	
	return "";
}

function longip($ip_long)
{
	if($ip_long <0)
		return "";
	
	//dec to hex
	$iphex = array();
	$i = 0;
	while($ip_long!=0) {
		$rslt = floor($ip_long/16); 
		$iphex[$i] = $ip_long - ($rslt*16);
		$ip_long = $rslt;
		$i++;
	}

	$ip = "";
	for($i=count($iphex)-1; $i>=0; $i--) {
		$ip .= dechex($iphex[$i]);
	}
	
	//convert hex to 12 digits
	while(strlen($ip)<8) {
		$ip = "0".$ip;
	}
	
	//convert hex to ip format
	if(strlen($ip) == 8) {
		$ip_array = array();
		
		$count = 0;
		for($i=0; $i<8; $i=$i+2) {
			$ip_array[$count] = hexdec(strtoupper(substr($ip, $i, 2)));
			$count++;
		}
			
		$ip = "$ip_array[3].$ip_array[2].$ip_array[1].$ip_array[0]";
		
		return $ip;
	}
	
	return "";
}
?>
<html>
<head>
<style type="text/css">
<!--
    table { font-family: Tahoma, sans-serif; font-size: 10pt; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    .add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    .delete { color: #FF0000; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green;
    #display { color: #000; list-style: none; margin: 0px; padding: 0;}
    #add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    #display li, #add li { padding-left: 10px; }
    #display span, #add span { width: 350px; float:left; }
    form { margin: 0;}
-->
</style>
</head>
<body>
<?php
$row = array();

//manipulate rows
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('c_Filter.php FSCONFIG.Cfgmgr Object cannot be created!');
$filter_path = realpath("..\\");
$filter_path = $filter_path."\\config.ini";
$session_handling = $settingobj->getKey("session_handling", "gateway");

if($session_handling==0)
{
	$filter_mac = isset($ser_filter_mac)? unserialize($ser_filter_mac) : array();
	$delete_mac = isset($ser_delete_mac)? unserialize($ser_delete_mac) : array();
	
	//added entries
	if(file_exists($filter_path))
	{
		$count = $settingobj->ReadINI("mac_filter", "mac_count", $filter_path);
		if($count>0) {
			for($i=0; $i<$count; $i++) {
				$mac_long = $settingobj->ReadINI("mac_filter", "mac_$i", $filter_path);
				$row[$i][0] = ($i%2)==0? "even":"odd";
				$row[$i][1] = long2mac($mac_long);
				$row[$i][2] = "<input type='checkbox' name='entry'>";
			}	
		}
	}
	
	//saved add entries
	$count = count($row);
	for($i=0; $i<count($filter_mac); $i++) {
		$pos = $i + $count;
		$row[$pos][0] = "add";
		$row[$pos][1] = $filter_mac[$i];
		$row[$pos][2] = "<input type='checkbox' name='entry'>";
	}	
	
	//new entries
	if(isset($mac) && $mac!="") {
		$count = count($row);
		$row[$count][0] = "add";
		$row[$count][1] = $mac;
		$row[$count][2] = "<input type='checkbox' name='entry'>";
		
		$filter_mac[count($filter_mac)] = $mac;
		
		$ser_filter_mac = serialize($filter_mac);
		session_register('ser_filter_mac');
	}
	
	//saved delete entries
	foreach ($delete_mac as $entry) {
		$row[$entry][0] = "delete";
		$row[$entry][1] = "# ".$row[$entry][1];
		$row[$entry][2] = "<input type='checkbox' name='entry' disabled>";
	}
	
	//new delete entries
	if(isset($delete) && $delete!="") {
		$temp = explode(',', $delete);	
		
		foreach ($temp as $entry) {
			$row[$entry][0] = "delete";
			$row[$entry][1] = "# ".$row[$entry][1];
			$row[$entry][2] = "<input type='checkbox' name='entry' disabled>";
		}
		
		$delete_mac = array_merge($delete_mac, $temp);
		$ser_delete_mac = serialize($delete_mac);
		session_register('ser_delete_mac');
	}
}
else if($session_handling==1)
{
	$filter_ip = isset($ser_filter_ip)? unserialize($ser_filter_ip) : array();
	$delete_ip = isset($ser_delete_ip)? unserialize($ser_delete_ip) : array();
	
	//added entries
	if(file_exists($filter_path))
	{
		$count = $settingobj->ReadINI("ip_filter", "ip_count", $filter_path);
		if($count>0) {
			for($i=0; $i<$count; $i++) {
				$ip_long = $settingobj->ReadINI("ip_filter", "ip_$i", $filter_path);
				$row[$i][0] = ($i%2)==0? "even":"odd";
				$row[$i][1] = longip($ip_long);
				$row[$i][2] = "<input type='checkbox' name='entry'>";
			}	
		}
	}
	
	//saved add entries
	$count = count($row);
	for($i=0; $i<count($filter_ip); $i++) {
		$pos = $i + $count;
		$row[$pos][0] = "add";
		$row[$pos][1] = $filter_ip[$i];
		$row[$pos][2] = "<input type='checkbox' name='entry' >";
	}	
	
	//new entries
	if(isset($ip) && $ip!="") {
		$count = count($row);
		$row[$count][0] = "add";
		$row[$count][1] = $ip;
		$row[$count][2] = "<input type='checkbox' name='entry' >";
		
		$filter_ip[count($filter_ip)] = $ip;
		
		$ser_filter_ip = serialize($filter_ip);
		session_register('ser_filter_ip');
	}
	
	//saved delete entries
	foreach ($delete_ip as $entry) {
		$row[$entry][0] = "delete";
		$row[$entry][1] = "# ".$row[$entry][1];
		$row[$entry][2] = "<input type='checkbox' name='entry' disabled>";
	}
	
	//new delete entries
	if(isset($delete) && $delete!="") {
		$temp = explode(',', $delete);	
		
		foreach ($temp as $entry) {
			$row[$entry][0] = "delete";
			$row[$entry][1] = "# ".$row[$entry][1];
			$row[$entry][2] = "<input type='checkbox' name='entry' disabled>";
		}
		
		$delete_ip = array_merge($delete_ip, $temp);
		$ser_delete_ip = serialize($delete_ip);
		session_register('ser_delete_ip');
	}
		
}

$settingobj=null;

echo table_new($row);

?>
</body>
</html>