<?php
require_once 'common_functions.php';

$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
$session_handling = $settingobj->getKey( "session_handling", "gateway");
$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
$siteID = $settingobj->getKey('siteID', 'gateway');

$use_radius = $settingobj->getKey( 'use_radius', 'radius');

// connect to database
if( strtolower($use_radius)== 'true' ) {
    $dsn_file = $settingobj->getKey( 'Datasource', 'radius');
}else{
	$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
}

$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
$dsn='';

if(!feof($dsn_source)) 
    $line=fgets($dsn_source,512); 

while(!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!='') $dsn.=$line;
}

$dsn=str_replace("\r\n",';',$dsn);

// 20080530 - Determine show IP or domain name
//determine if it's SSL or not
$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
if (isset($showDomainUrl) && $showDomainUrl > 0) {
    $urlhead = fs_local_domain_url();
} else {
    $urlhead = fs_local_ip_url();
}

$settingobj=null;

// checking this page call from fsRedirector (match private ip and server name)
if(isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] == $ip_address && isset($_SERVER['HTTP_SERVER']) && $_SERVER['HTTP_SERVER'] == "FirstSpotDispatcher"){
	if (isset($_GET['request']) && $_GET['request'] != "none" && isset($_GET['patronsoft1']) &&  isset($_GET['patronsoft2'])){
		
		$userDB=odbc_connect($dsn,'','');
		
		$condition1="";
		$reserved1="";
		$q="";
		
		if ($isScenario2)
			$condition1=" AND siteID ='".$siteID."'";
		
		if ($session_handling == 1){
			$reserved1=$_GET['patronsoft1'];
		}else{
			$reserved1=$_GET['patronsoft2'];
		}
		
		$q = 'select name from '.fs_usr_table()." where reserved1 = '".$reserved1."'".$condition1.";";	

		$result = odbc_exec( $userDB, $q );
		$username = odbc_result( $result, 'name' );
		odbc_free_result( $result );
		if ($username != ""){
			if(!session_id())
				session_start();
			$_SESSION['session_username'] = $username;
			$_SESSION['sess_patronsoft1'] = $patronsoft1;
			$_SESSION['sess_patronsoft2'] = $patronsoft2;
			
			if (strtolower($use_radius) != 'true'){
				// For passive login not display change password link
				$q = 'select count(*) as num from '.fs_usr_table()." where name = '".$username."' AND MACasUsr='Y' AND pwd is null ;";	
				$result = odbc_exec( $userDB, $q );
				$isPassiveLogin = odbc_result( $result, 'num' );
				odbc_free_result( $result );
				odbc_close( $userDB );
				if($isPassiveLogin>0){
					// passive login
					$_SESSION['show_change_password_link'] = '0';
				}else
					$_SESSION['show_change_password_link'] = '1';
			}
			
		}else{			
			// not logged in
			header ("Location: ".$urlhead. "/iKeyRedirect_warning.php?err=3");
			odbc_close( $userDB );
			exit();
		}
		header ("Location: ".$urlhead. "/iKeyRedirectScript.php?request=".$_GET['request']);
		exit();
	}else{
		header ("Location: ".$urlhead. "/iKeyRedirect_warning.php?err=2");
		exit();
	}
}else{
	header ("Location: ".$urlhead. "/iKeyRedirect_warning.php?err=1");
	exit();
}

?>