<?
$wait_b4_redirect = 10;
$wait_b4_to_fail_page = 5;

function print_gen_line($input) 
{
    echo "
        <style type=\"text/css\">
        SPAN.errortext {font-size:14pt; FONT-WEIGHT: bold;}
        </style>

        <table width=\"90%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">
            <tr>
              <td width=\"10%\">&nbsp;</td>
              <td width=\"90%\">&nbsp;</td>
            </tr>
            <tr>
                <td width=\"10%\">&nbsp;</td>
                <td width=\"90%\" valign=\"top\" align=\"left\">".$input."</td>
            </tr>
            <tr>
              <td width=\"10%\">&nbsp;</td>
              <td width=\"90%\">&nbsp;</td>
            </tr>
        </table>
    ";

}

function unregister_sess()
{
    if(isset($sess_apiFunc))
        session_unregister("sess_apiFunc");
    if(isset($sess_apiRespType))
        session_unregister("sess_apiRespType");
    if(isset($sess_jobReferenceID))
        session_unregister("sess_jobReferenceID");
    if(isset($sess_jobDestination))
        session_unregister("sess_jobDestination");
    if(isset($sess_jobPageCount))
        session_unregister("sess_jobPageCount");
    if(isset($sess_jobPriceTotal))
        session_unregister("sess_jobPriceTotal");
    if(isset($sess_jobType))
        session_unregister("sess_jobType");
    if(isset($systemUID))
        session_unregister("systemUID");
    if(isset($sess_requestToken))
        session_unregister("sess_requestToken");
    if(isset($sess_apiRespURL))
        session_unregister("sess_apiRespURL");
}


header("Cache-Control: no-cache, must-revalidate");
require_once "..\\authserv\\common_functions.php";
require_once "..\\authserv\\fs_lang.php";

if(isset($apiFunc)) {
    if(!isset($sess_apiFunc))
        session_register("sess_apiFunc");
    $sess_apiFunc=$apiFunc;
}
if(isset($apiRespType)) {
    if(!isset($sess_apiRespType))
        session_register("sess_apiRespType");
    $sess_apiRespType=$apiRespType;
}
if(isset($jobReferenceID)) {
    if(!isset($sess_jobReferenceID))
        session_register("sess_jobReferenceID");
    $sess_jobReferenceID=$jobReferenceID;
}
if(isset($jobDestination)) {
    if(!isset($sess_jobDestination))
        session_register("sess_jobDestination");
    $sess_jobDestination=$jobDestination;
}
if(isset($jobPageCount)) {
    if(!isset($sess_jobPageCount))
        session_register("sess_jobPageCount");
    $sess_jobPageCount=$jobPageCount;
}
if(isset($jobPriceTotal)) {
    if(!isset($sess_jobPriceTotal))
        session_register("sess_jobPriceTotal");
    $sess_jobPriceTotal=$jobPriceTotal;
}
if(isset($jobType)) {
    if(!isset($sess_jobType))
        session_register("sess_jobType");
    $sess_jobType=$jobType;
}
if(isset($systemUID)) {
    if(!isset($sess_systemUID))
        session_register("systemUID");
    $sess_systemUID=$systemUID;
}
if(isset($requestToken)) {
    if(!isset($sess_requestToken))
        session_register("sess_requestToken");
    $sess_requestToken=$requestToken;
}
if(isset($apiRespURL)) {
    if(!isset($sess_apiRespURL))
        session_register("sess_apiRespURL");
    $sess_apiRespURL=$apiRespURL;
}

$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');

$version = $settingobj->getKey('version', 'version');

// release the COM object
//$settingobj->Release();
$settingobj=null;

// 20090518 - Remove Start
// version control
if (substr_count(strtolower($version), "standard") > 0) {
    if (substr_count(strtolower($version),"donation")>0)
        $version = substr($version,0,strlen($version)-9);
    $version_check = false;
} else {
    $version_check = true;

}

if (isset($sess_jobReferenceID) && isset($sess_jobPageCount) && isset($sess_apiRespURL) && isset($username) && $version_check)
{
    $settingobj = new COM("FSCONFIG.Cfgmgr") or die("print_auth.php Object cannot be created!");
    $radius = $settingobj->getKey( "use_radius", "radius" );

    if( $radius=="true" ){
        $FSAuthObj = new COM('FSAUTH.Authserv') or die('print_auth.php FSAUTH.Authserv Object cannot be created!');
        $totalpage = $FSAuthObj->GetPrintQuota($username,$password,$_SERVER['REMOTE_ADDR']);
        //$FSAuthObj->Release();
        $FSAuthObj=null;
    }
    //$settingobj->Release();
    $settingobj=null;
    if($radius=="true" || fs_is_password_correct($username,$password))
    {
        if( $radius!="true" ){
            $q="SELECT pagenum FROM ".fs_usr_table()." where name = '$username'";
            $result=db_query($q);
            $totalpage = 0;
            while(odbc_fetch_row($result))
            {
                $totalpage = odbc_result($result,1);
                if ($totalpage!="" || $totalpage!=null)
                    $totalpage=round(odbc_result($result,1));
            }
        }

        if ($totalpage!="" || $totalpage!=null)
            $pageleft = $totalpage-$sess_jobPageCount;
        else
            $pageleft = "Unlimited";

        if( isset($sess_jobPageCount) && ( ($pageleft)>=0 || $pageleft=="Unlimited" ) )
        {
            $settingobj = new COM("FSCONFIG.Cfgmgr") or die("print_auth.php Object cannot be created!");
            $siteUID=$settingobj->getKey( "SiteUID", "PrinterOn");
            $siteAuth=$settingobj->getKey( "SiteAuth", "PrinterOn");

            if(isset($sess_requestToken) && $sess_requestToken!="" && $siteUID!="" && $siteAuth!="")
            {

                $h = mhash(MHASH_MD5,$siteUID.",".$siteAuth);

                if (isset($sess_jobPriceTotal) && $sess_jobPriceTotal != "")
                {
                    $req_token = bin2hex(mhash(MHASH_MD5,bin2hex($h).",".$sess_jobReferenceID.",".$sess_jobPageCount.",".$sess_jobPriceTotal.""));
                }
                else
                {
                    $req_token = bin2hex(mhash(MHASH_MD5,bin2hex($h).",".$sess_jobReferenceID.",".$sess_jobPageCount.","));
                }   

                if(strcmp($req_token, $sess_requestToken) == 0 )
                {
                    $authorized = "TRUE";
                    $resp_token = bin2hex(mhash(MHASH_MD5,bin2hex($h).",".$sess_jobReferenceID.",".$authorized.""));

                    $datetime = date("Y-m-d H:i:s");
                    $q="INSERT INTO ".fs_printlog_table()." (REFID, USERNAME, LOGTIME, PAGE, STAT, PRICE, JOBTYPE, DESTID, SYSID) values( '$sess_jobReferenceID', '$username', '$datetime', $sess_jobPageCount, 'PENDING', ";

                    if(isset($sess_jobPriceTotal))
                    {
                        $q.= "".$sess_jobPriceTotal.",";
                    }
                    else
                        $q.= "NULL,";
                    if(isset($sess_jobType))
                    {
                        $q.= "'$sess_jobType', ";
                    }
                    else
                        $q.= "NULL,";

                    if(isset($sess_jobDestination))
                    {
                        $q.= "'$sess_jobDestination', ";
                    }
                    else
                        $q.= "NULL,";

                    if(isset($sess_systemUID))
                    {
                        $q.= "'$sess_systemUID');";
                    }
                    else
                        $q.= "NULL);";

                    $result_insert=db_query($q);

                    $posturl =  $sess_apiRespURL ."&jobReferenceID=".$sess_jobReferenceID."&authorizeProtocol=MD5&authorizeToken=".$resp_token."&apiFunc=AuthorizeJobResponse&approveUse=TRUE";
                    echo "<meta http-equiv=\"REFRESH\" content=\"5;URL=".$posturl."\">";
                    $input = get_var('print_username').$username."<BR>".get_var('print_ref_id').$sess_jobReferenceID."<BR>".get_var('print_page_count').$sess_jobPageCount."<BR>".get_var('print_page_left').$pageleft."<BR>";
                    print_gen_line($input);
                    unregister_sess();
                    exit;
                }
                else
                {
                    $input = "<span class=\"errortext\">" . get_var('print_error_token')."</span>";
                    print_gen_line($input);
                    echo "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=print_form.php'>"; 

                }
            }
            else
            {
                $datetime = date("Y-m-d H:i:s");
                $q="INSERT INTO ".fs_printlog_table()." (REFID, USERNAME, LOGTIME, PAGE, STAT, PRICE, JOBTYPE, DESTID, SYSID) values( '$sess_jobReferenceID', '$username', '$datetime', $sess_jobPageCount, 'PENDING', ";

                if(isset($sess_jobPriceTotal))
                {
                    $q.= "".$sess_jobPriceTotal.",";
                }
                else
                    $q.= "NULL,";
                if(isset($sess_jobType))
                {
                    $q.= "'$sess_jobType', ";
                }
                else
                    $q.= "NULL,";

                if(isset($sess_jobDestination))
                {
                    $q.= "'$sess_jobDestination', ";
                }
                else
                    $q.= "NULL,";

                if(isset($sess_systemUID))
                {
                    $q.= "'$sess_systemUID');";
                }
                else
                    $q.= "NULL);";

                $result_insert=db_query($q);

                $posturl =  $sess_apiRespURL ."&apiFunc=AuthorizeJobResponse&approveUse=TRUE";
                echo "<meta http-equiv=\"REFRESH\" content=\"5;URL=".$posturl."\">";
                $input = get_var('print_username').$username."<BR>".get_var('print_ref_id').$sess_jobReferenceID."<BR>".get_var('print_page_count').$sess_jobPageCount."<BR>".get_var('print_page_left').$pageleft."<BR>";
                print_gen_line($input);
                unregister_sess();
                exit;
            }
            //$settingobj->Release();
            $settingobj=null;
        }
        else
        {
            $input = "<span class=\"errortext\">" . get_var('print_error_quota')."</span>";
            print_gen_line($input);
            echo "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=print_form.php'>"; 
        }

    }
    else
    {
        $input = "<span class=\"errortext\">" . get_var('print_error_pwd')."</span>";
        print_gen_line($input);

        echo "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=print_form.php'>"; 
    }
}

?>
