<?php
include_once("db_access.php");
include_once("..\\authserv\\common_functions.php");

$settingobj = new COM('FSCONFIG.Cfgmgr') or die('settingok.php FSCONFIG.Cfgmgr Object cannot be created!');
$low = $settingobj->getKey('bt_low', 'bw_throttle');
$medium = $settingobj->getKey('bt_medium', 'bw_throttle');
$high = $settingobj->getKey('bt_high', 'bw_throttle');
$session_handling = $settingobj->getKey('session_handling', 'gateway');
//$settingobj->Release();
$settingobj=null;

$bt_ul_limit=null;
$bt_dl_limit=null;

if(!isset($plan_bt_mode))
    $plan_bt_mode=4;   // default is "use Global Setting"
switch($plan_bt_mode)
{
case 0:
    $bt_ul_limit=0;
    $bt_dl_limit=0;
    break;
case 1:
    $bt_ul_limit=$low;
    $bt_dl_limit=$low;
    break;
case 2:
    $bt_ul_limit=$medium;
    $bt_dl_limit=$medium;
    break;
case 3:
    $bt_ul_limit=$high;
    $bt_dl_limit=$high;
    break;
case 4:
    $bt_ul_limit=null;
    $bt_dl_limit=null;
    break;
case 5:  // treat as 0 (no throttling) if it is blank
    if (!isset($plan_bt_num) || $plan_bt_num=='')
        $plan_bt_num=0;
    if (!isset($plan_bt_num_dl) || $plan_bt_num_dl=='')
        $plan_bt_num_dl=0;
    $bt_ul_limit=$plan_bt_num;
    $bt_dl_limit=$plan_bt_num_dl;
    break;
}

$active_acc=0;
$startDate=null;
if(isset($bt_act_acc)) {
    switch($bt_act_acc)
    {
    case 0:
        $active_acc=0;
        break;  
    case 1:
        $active_acc=1;      
        break;
    case 2:
        $active_acc=2;
        if (isset($act_date))
            $startDate=datetime_from_php($act_date, $act_time);
        break;
    }
}

$status=0;
if(isset($bt_plan_status))
{
    switch($bt_plan_status)
    {
    case 0:
        $status=0;
        break;  
    case 1:
        $status=1;
        break;
    }
}

$timeleft=null;
$logins=null;
$endDate=null;
$mins=null;

if(!isset($cb_exp_acc0)) { //not never
    if(isset($cb_exp_acc1))  //timeleft
    {
        $timeleft=$exp_timeleft;
    }
    if(isset($cb_exp_acc2)) //login
    {
        $logins=$exp_login;
    }
    if(isset($cb_exp_acc3))  //date
    {
        $endDate=datetime_from_php($exp_date, $exp_time);
    }
    if(isset($cb_exp_acc4)) {
        if(strcmp($select_exp_timeleft,'min')==0)
            $mins=$exp_days;
        else if (strcmp($select_exp_timeleft,'hour')==0)
            $mins=$exp_days*60;
        else
            $mins=$exp_days*60*24;
    }
}

$bwcount=null;
$bwquota=null;
$accumbw=null;
if(isset($plan_bwcount)) {
    switch($plan_bwcount)
    {
    case -1:
        $bwcount=null;
        break;
    case 0:
        $bwcount=0;
        break;
    case 1:
        $bwcount=1;
        $accumbw=0;
        break;
    case 2:
        $bwcount=2;
        $bwquota=$plan_bwquota1;
        $accumbw=0;
        break;
    }
}

$bwcountUL=null;
$bwquotaUL=null;
$accumbwUL=null;
if(isset($plan_bwcountUL)) {
    switch($plan_bwcountUL)
    {
    case -1:
        $bwcountUL=null;
        break;
    case 0:
        $bwcountUL=0;
        break;
    case 1:
        $bwcountUL=1;
        $accumbwUL=0;
        break;
    case 2:
        $bwcountUL=2;
        $bwquotaUL=$plan_bwquota1UL;
        $accumbwUL=0;
        break;
    }
}

$bwcountSHA=null;
$bwquotaSHA=null;
$accumbwSHA=null;
if(isset($plan_bwcountSHA)) {
    switch($plan_bwcountSHA)
    {
    case 0:
        $bwcountSHA=0;
        break;
    case 1:
        $bwcountSHA=1;
        $accumbwSHA=0;
		$bwcount = 0;
		$bwcountUL = 0;
		echo '<script type="text/javascript">';
		echo 'alert( "'.get_cm_var('setcfg_data_transfer_remind').'");';
		echo '</script>';
        break;
    case 2:
        $bwcountSHA=2;
        $bwquotaSHA=$plan_bwquota1SHA;
        $accumbwSHA=0;
		$bwcount = 0;
		$bwcountUL = 0;
		echo '<script type="text/javascript">';
		echo 'alert( "'.get_cm_var('setcfg_data_transfer_remind').'");';
		echo '</script>';
        break;
    }
}


//plan recur_option
if(isset($plans_recur_option) && $plans_recur_option == 1)
{
    $week_sch = 0;
    if (isset($plans_cb_mon))
        $week_sch += $plans_cb_mon;
    if (isset($plans_cb_tue))
        $week_sch += $plans_cb_tue;
    if (isset($plans_cb_wed))
        $week_sch += $plans_cb_wed;
    if (isset($plans_cb_thr))
        $week_sch += $plans_cb_thr;
    if (isset($plans_cb_fri))
        $week_sch += $plans_cb_fri;
    if (isset($plans_cb_sat))
        $week_sch += $plans_cb_sat;
    if (isset($plans_cb_sun))
        $week_sch += $plans_cb_sun;
    
    $plans_recur_sdate="";
    $plans_recur_edate="";
    if (isset($plans_recur_stime) && strlen($plans_recur_stime) > 0) {
        $plans_recur_sdate = $plans_recur_stime;
    }

    if (isset($plans_recur_etime) && strlen($plans_recur_etime) > 0) {
        $plans_recur_edate = $plans_recur_etime;
    }
} else {
    $plans_recur_option = 0;
    $plans_recur_sdate="";
    $plans_recur_edate="";
    $week_sch = 0;
}

if(!isset($plan_usr_abw_rm))
    $plan_usr_abw_rm = 3;

switch($plan_usr_abw_rm)
{
case 0:
    $plan_bwrmethod = 'disable';
    $plan_bwrperiod = NULL;
    $plan_bwrdate = NULL;
    break;
case 1:
    if(!is_numeric($plan_usr_abw_rdate)||$plan_usr_abw_rdate<1||$plan_usr_abw_rdate>31)
        $plan_usr_abw_rdate = 1;
    if(!isset($plan_usr_abw_rp_1)||$plan_usr_abw_rp_1<1)
        $plan_usr_abw_rp_1 = 1;

    $plan_bwrmethod = 'month';
    $plan_bwrdate = $plan_usr_abw_rdate;
    $plan_bwrperiod = $plan_usr_abw_rp_1;
    break;
case 2:
    if(!is_numeric($plan_usr_abw_rp_2)||$plan_usr_abw_rp_2<1)
        $plan_usr_abw_rp_2 = 1;

    $plan_bwrmethod = 'day';
    $plan_bwrperiod = $plan_usr_abw_rp_2;
    $todayTime = time(NULL);
    $todayDate = getdate($todayTime);
    $plan_bwrdate = $todayDate['mday'];
    break;
case 3:
default:
    $plan_bwrmethod = NULL;
    $plan_bwrperiod = NULL;
    $plan_bwrdate = NULL;
    break;
}

//print quota
if (isset($plan_printQuota)){
    if ($plan_printQuota)
        $plan_printQuota = round($plan_printQuota);
    else
        $plan_printQuota = NULL;
}
else
    $plan_printQuota = NULL;

//access control list
if (isset($plan_acl) && $plan_acl=='y')
    $plan_acl = "Y";
else
    $plan_acl = NULL;

//request signup
if (isset($plan_signup) && $plan_signup=='y')
    $plan_signup = "Y";
else
    $plan_signup = NULL;

//reset option
if (isset($reset_opt) && $reset_opt=='y')
    $reset_opt = 1;
else
    $reset_opt = 0;

//auto_del
if (isset($plan_autodel) && strtolower($plan_autodel)=='y')
	$plan_autodel = 1;
else
	$plan_autodel = 0;
	
//mac mapping
if (isset($mac_map) && strtolower($mac_map)=='y')
	$mac_map = 1;
else
	$mac_map = 0;

//ip mapping
if (isset($ip_map) && strtolower($ip_map)=='y')
	$ip_map = 1;
else
	$ip_map = 0;
	
$myDB = new db();
$plan_table = $myDB->get_plan_table();

$fields = array();
//$fields['pname'] = $planname;
$fields["timeleft"] = $timeleft;
$fields["btul"] = $bt_ul_limit;
$fields["btdl"] = $bt_dl_limit;
$fields["bwquota"] = $bwquota;
$fields["bwcount"] = $bwcount;  
$fields["bwquotaul"] = $bwquotaUL;
$fields["bwcountul"] = $bwcountUL;
$fields["status"] = $status;
$fields["startmod"] = $active_acc;
$fields["edate"] = $endDate;
$fields["sdate"] = $startDate;  
$fields["logins"] = $logins;
$fields["eminutes"] = $mins;    
$fields["auto_del"] = $plan_autodel;  
$fields["bwrmethod"] = $plan_bwrmethod;
$fields["bwrperiod"] = $plan_bwrperiod;
$fields["bwrdate"] = $plan_bwrdate;
$fields["reqsignup"] = $plan_signup; 
$fields["pagenum"] = $plan_printQuota;   
$fields["acl"] = $plan_acl;
$fields["roption"] = $plans_recur_option; 
$fields["rsdate"] = $plans_recur_sdate;  
$fields["redate"] = $plans_recur_edate;  
$fields["weeksch"] = $week_sch;
$fields["resetopt"] = $reset_opt;
$fields["macmap"] = $mac_map;
$fields["ipmap"] = $ip_map;
$fields["bwcountsha"] = $bwcountSHA;
$fields["bwquotasha"] = $bwquotaSHA;

// 20090708 - Add array to store field data type
$bFieldNumeric = array();
$bFieldNumeric["timeleft"] = 1;
$bFieldNumeric["btul"] = 1;
$bFieldNumeric["btdl"] = 1;
$bFieldNumeric["bwquota"] = 1;
$bFieldNumeric["bwcount"] = 1;
$bFieldNumeric["bwquotaul"] = 1;
$bFieldNumeric["bwcountul"] = 1;
$bFieldNumeric["status"] = 1;
$bFieldNumeric["startmod"] = 1;
$bFieldNumeric["edate"] = 0;
$bFieldNumeric["sdate"] = 0;
$bFieldNumeric["logins"] = 1;
$bFieldNumeric["eminutes"] = 1;
$bFieldNumeric["auto_del"] = 1;
$bFieldNumeric["bwrmethod"] = 0;
$bFieldNumeric["bwrperiod"] = 1;
$bFieldNumeric["bwrdate"] = 1;
$bFieldNumeric["reqsignup"] = 0;
$bFieldNumeric["pagenum"] = 1;
$bFieldNumeric["acl"] = 0;
$bFieldNumeric["roption"] = 1;
$bFieldNumeric["rsdate"] = 0;
$bFieldNumeric["redate"] = 0;
$bFieldNumeric["weeksch"] = 1;
$bFieldNumeric["resetopt"] = 1;
$bFieldNumeric["macmap"] = 1;
$bFieldNumeric["ipmap"] = 1;
$bFieldNumeric["bwcountsha"] = 1;
$bFieldNumeric["bwquotasha"] = 1;

if (isset($save_p)&&($save_p=='true'))
{
	// 20090708 - Pass also the data type array with the field array
    if ($addplan=='true') {
        if ( !$myDB->isexists($plan_table, "pname='".$planname."'") ) {
			$fields['pname'] = $planname;
			$bFieldNumeric['pname'] = 0;
			$result = $myDB->insert($plan_table, $fields, $bFieldNumeric);
            if ($result = false)
                $_SESSION['message']='Failed to Add plan';
            else
                $_SESSION['message']='User plan information was successfully added.';
            $myDB->close();
        } else {
            $_SESSION['message']='Warning: The plan name chosen has been held. Please choose another one.';
        }
    } else if ($editplan=="true") {		
		
        if ( $myDB->isexists($plan_table, "pname='".$planname."'") ) {
			$result = $myDB->update($plan_table, $fields, "WHERE pname = '".$planname."'", $bFieldNumeric);
            if ($result = false)
                $_SESSION['message']='Failed to update plan';
            else
                $_SESSION['message']='User plan information was successfully saved. The current users under this plan will not be affected.';
            $myDB->close();
        } else {
            $_SESSION['message']='Warning: The plan name chosen does not exists.';
        }
    }

    echo '<script type="text/javascript">';
    echo 'parent.parent.mid_right_bottom.location.reload();';
    echo '</script>';
    
}
?>
    <tr>
        <td width="100%" colspan="5" valign="top" height="15"><img src="./images/blank.gif" border="0" width="15" height="15"></td>
    </tr>

    <tr>
        <td width="210" valign="top" class="captionbig">
            <span class="star"><?=$version_msg.'&nbsp;</span><br><br><br><span style="color: green;">'.get_cm_var('setcfg_plans_existing_plans').'</span>'?>
            <iframe id="plans" name="plans" frameborder="0" width="170" height="360" src="plans.php" marginwidth="0" marginheight="0" style="border:0;"></iframe>
        </td>
        <td width="100%" valign="top">
    <div id="buttons">    
        <input type="button" class="graphicBtn" value="<?=get_cm_var('setcfg_plans_btn_add')?>" title="<?=get_cm_var('setcfg_plans_add_plan')?>" onClick="onAdd();" <?=$disabled?>>
        <input type="button" class="graphicBtn" value="<?=get_cm_var('setcfg_plans_btn_edit')?>" title="<?=get_cm_var('setcfg_plans_edit_plan')?>" onClick="onEdit();" <?=$disabled?>>
        <input type="button" class="graphicBtn" value="<?=get_cm_var('setcfg_plans_btn_delete')?>" title="<?=get_cm_var('setcfg_plans_delete_plan')?>" onClick="deletePlan()" <?=$disabled?>>
    </div>
    <br>

    <form action="" name="planform" method="post" onSubmit="return validate_p();">
    <input type="hidden" name="disabled" value="<?=$disabled?>">
    <input type="hidden" name="save_p" value="true">
    <input type="hidden" name="addplan" value="">
    <input type="hidden" name="editplan" value="">
    <input type="hidden" name="plan_no" id="plan_no" value="">

    <table width="100%" border="0" cellspacing="0" cellpadding="1">
    <tr class="captionbig" style="color:green;">
        <td width="10" class="tabspace">&nbsp;</td>
        <td width="120" align="center" class="tabselected"><span id="tabtitle">Plan Details</span></td>
        <td class="tabspace">&nbsp;</td>
    </tr>
    </table>
    <script type="text/javascript"><!--
    function changeTab()
    {
        obj = document.getElementById('tabtitle');
        if (document.planform.addplan.value == 'true')
            obj.innerHTML = '<?=get_cm_var('setcfg_plans_add_plan')?>';
        else if (document.planform.editplan.value == 'true')
            obj.innerHTML = '<?=get_cm_var('setcfg_plans_edit_plan')?>';
        else
            obj.innerHTML = '<?=get_cm_var('setcfg_plans_plan_info')?>';
    }
    // -->
    </script>

    <table width="100%" border="0" cellspacing="0" cellpadding="0" class="tabcontent" >
    <tr><td colspan="2"><br></td></tr>
    <tr valign="top">
        <td width="35%" class="captionbig"><?=get_cm_var('setcfg_plans_plan_name')?></td>
        <td width="65%"><input type="text" name="planname" id="planname" value="" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;"></td>
    </tr>

    <tr><td colspan="2"><br></td></tr>
    <tr valign="top"><td class="captionbig"><?=get_cm_var('setcfg_plans_account_status'); ?></td>
        <td class="captionbig">
        <input type="radio" name="bt_plan_status" value="0"><?=get_cm_var('setcfg_plans_account_enable'); ?> <br>
        <input type="radio" name="bt_plan_status" value="1"><?=get_cm_var('setcfg_plans_account_disable'); ?>
        </td>
    </tr>

    <tr><td colspan="2"><br></td></tr>
    <tr valign="top"><td class="captionbig"><?=get_cm_var('setcfg_plans_activate_account'); ?></td>
        <td class="captionbig">
        <input type="radio" name="bt_act_acc" value="0" onClick="activateAcc('0')" ><?=get_cm_var('setcfg_plans_account_is_created'); ?> <br>
        <input type="radio" name="bt_act_acc" value="1" onClick="activateAcc('1')"><?=get_cm_var('setcfg_plans_first_login'); ?> <br>
        <input type="radio" name="bt_act_acc" value="2" onClick="activateAcc('2')"><?=get_cm_var('setcfg_plans_date'); ?>
        <input class="shorttextbox" type="text" name="act_date" maxlength="10" value="">&nbsp;
        <input class="timetextbox" type="text" name="act_time" maxlength="5" value=""><br>
        <?=get_cm_var('setcfg_recur_name')?>&nbsp;
        <input type="radio" name="plans_recur_option" value="1" onClick="plans_recur_disabled(this)" disabled><?=get_cm_var('setcfg_recur_option_on')?>&nbsp;
        <input type="radio" name="plans_recur_option" value="0" onClick="plans_recur_disabled(this)" checked disabled><?=get_cm_var('setcfg_recur_option_off')?>&nbsp;<br />
        <tr id="plans_schedule" style="display: 'none'">
          <td class="captionbig"></td>
          <td class="captionbig">
            <input type="checkbox" name="plans_cb_mon" value="2"><?=get_cm_var('setcfg_mon')?>&nbsp;
            <input type="checkbox" name="plans_cb_tue" value="4"><?=get_cm_var('setcfg_tue')?>&nbsp;
            <input type="checkbox" name="plans_cb_wed" value="8"><?=get_cm_var('setcfg_wed')?>&nbsp;
            <input type="checkbox" name="plans_cb_thr" value="16"><?=get_cm_var('setcfg_thr')?>&nbsp;<br>
            <input type="checkbox" name="plans_cb_fri" value="32"><?=get_cm_var('setcfg_fri')?>&nbsp;
            <input type="checkbox" name="plans_cb_sat" value="64"><?=get_cm_var('setcfg_sat')?>&nbsp;
            <input type="checkbox" name="plans_cb_sun" value="1"><?=get_cm_var('setcfg_sun')?>&nbsp;<br>
            <?=get_cm_var('setcfg_recur_start_end_time')?>&nbsp;<br />
            <?=get_cm_var('setcfg_recur_time_format')?>&nbsp;<br>
            <input class="shorttextbox" type="text" name="plans_recur_stime" maxlength="5" value"" style="width:65px"> -
            <input class="shorttextbox" type="text" name="plans_recur_etime" maxlength="5" value"" style="width:65px">
          </td>
        </tr>
        </td>
    </tr>

<?php /**************************************************** Reset Option ******************************************/ ?>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_resetopt_enabled')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="reset_opt" value="y" disabled />
            <?=get_cm_var('setcfg_resetopt_yes')?>
            <input type="radio" name="reset_opt" value="n" disabled checked />
            <?=get_cm_var('setcfg_resetopt_no')?>
        </td>
    </tr>

<?php /**************************************************** Account Activation ******************************************/ ?>
    <tr><td colspan="2"><br></td></tr>
    <tr valign="top"><td id="expireAcc" class="captionbig"><?=get_cm_var('setcfg_plans_expire_account'); ?></td>
        <td class="captionbig">
        <input type="checkbox" name="cb_exp_acc0" value="0" onClick="expireAcc('0')"><?=get_cm_var('setcfg_plans_never'); ?><br>
        <input type="checkbox" name="cb_exp_acc1" value="1" onClick="expireAcc('1')"><?=get_cm_var('setcfg_plans_timeleft'); ?>&nbsp;<input class="shorttextbox" type="text" name="exp_timeleft" maxlength="10" value=""></br>
        <input type="checkbox" name="cb_exp_acc2" value="2" onClick="expireAcc('2')"><?=get_cm_var('setcfg_plans_login'); ?>&nbsp;<input class="shorttextbox" type="text" name="exp_login" maxlength="10" value=""></br>
        <input type="checkbox" name="cb_exp_acc3" value="3" onClick="expireAcc('3')"><?=get_cm_var('setcfg_plans_on_date'); ?>&nbsp;<input class="shorttextbox" type="text" name="exp_date" maxlength="10" value="">&nbsp;<input class="timetextbox" type="text" name="exp_time" maxlength="5" value=""></br>
        <input type="checkbox" name="cb_exp_acc4" value="4" onClick="expireAcc('4')"><?=get_cm_var('setcfg_plans_minutes'); ?>&nbsp;<input class="shorttextbox" type="text" name="exp_days" maxlength="8" value="">&nbsp;<select NAME="select_exp_timeleft"><option VALUE="min">Minute(s)<option VALUE="hour">Hour(s)<option VALUE="day">Day(s)</select>
        </td>
    </tr>

    <tr><td colspan="2"><br></td></tr>
    <tr valign="top"><td class="captionbig"><?=$version_star.get_cm_var('setcfg_plans_bt'); ?></td>
        <td class="captionbig">
        <input type="radio" name="plan_bt_mode" value="0" onClick="planrbtn('0')"><?=get_cm_var('setcfg_plans_no_throttling'); ?><br>
        <input type="radio" name="plan_bt_mode" value="1" onClick="planrbtn('1')"><?=get_cm_var('setcfg_plans_low'); ?>(~<?=$bt_num_low?> KBytes/s)<br>
        <input type="radio" name="plan_bt_mode" value="2" onClick="planrbtn('2')"><?=get_cm_var('setcfg_plans_medium'); ?>(~<?=$bt_num_medium?> KBytes/s)<br>
        <input type="radio" name="plan_bt_mode" value="3" onClick="planrbtn('3')"><?=get_cm_var('setcfg_plans_high'); ?>(~<?=$bt_num_high?> KBytes/s)<br>
        <input type="radio" name="plan_bt_mode" value="4" onClick="planrbtn('4')"><?=get_cm_var('setcfg_plans_use_global_setting1'); ?><br>
        <input type="radio" name="plan_bt_mode" value="5" onClick="planrbtn('5')"><?=get_cm_var('setcfg_plans_upload'); ?><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="plan_bt_num" maxlength="10" value="" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;"> <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?=get_cm_var('setcfg_plans_download'); ?><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="plan_bt_num_dl" maxlength="10" value="" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;">
        </td>
    </tr>

<?php /**************************************************** UPLOAD REPORT ******************************************/ ?>

    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2" class="captionbig">UPLOAD</td></tr>
    <tr valign="top">
        <td class="captionbig"><?=$version_star.get_cm_var('setcfg_plans_bandwith_counting_option')?></td>
        <td class="captionbig">
        <input type="radio" name="plan_bwcountUL" value="-1" onClick="planbwparamUL('-1')"><?=get_cm_var('setcfg_plans_global_counting')?><br>
        <input type="radio" name="plan_bwcountUL" value="0" onClick="planbwparamUL('0')"><?=get_cm_var('setcfg_plans_disable_counting')?><br>
        <input type="radio" name="plan_bwcountUL" value="1" onClick="planbwparamUL('1')"><?=get_cm_var('setcfg_plans_enable_counting')?><br>
        <input type="radio" name="plan_bwcountUL" value="2" onClick="planbwparamUL('2')"><font id="bwcountUL_color"><?=get_cm_var('setcfg_plans_enable_counting_and_quota')?></font>
        </td>
    </tr>
    <tr>
        <td class="captionbig"><?=get_cm_var('setcfg_plans_bandwidth_quota')?>&nbsp;</td>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="plan_bwquota1UL" id="plan_bwquota1UL" maxlength="10" value="" style="width:100px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" onKeyPress="return numbersonly(this,event)"></td>
    </tr>

<?php /**************************************************** DOWNLOAD REPORT ******************************************/ ?>

    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2" class="captionbig">DOWNLOAD</td></tr>
    <tr valign="top">
        <td class="captionbig"><?=$version_star.get_cm_var('setcfg_plans_bandwith_counting_option')?></td>
        <td class="captionbig">
        <input type="radio" name="plan_bwcount" value="-1" onClick="planbwparam('-1')"><?=get_cm_var('setcfg_plans_global_counting')?><br>
        <input type="radio" name="plan_bwcount" value="0" onClick="planbwparam('0')"><?=get_cm_var('setcfg_plans_disable_counting')?><br>
        <input type="radio" name="plan_bwcount" value="1" onClick="planbwparam('1')"><?=get_cm_var('setcfg_plans_enable_counting')?><br>
        <input type="radio" name="plan_bwcount" value="2" onClick="planbwparam('2')"><font id="bwcount_color"><?=get_cm_var('setcfg_plans_enable_counting_and_quota')?></font>
        </td>
    </tr>
    <tr>
        <td class="captionbig"><?=get_cm_var('setcfg_plans_bandwidth_quota')?>&nbsp;</td>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="plan_bwquota1" id="plan_bwquota1" maxlength="10" value="" style="width:100px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" onKeyPress="return numbersonly(this,event)"></td>
    </tr>

	
<?php /**************************************************** TOTAL REPORT ******************************************/ ?>

    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2" class="captionbig">TOTAL</td></tr>
    <tr valign="top">
        <td class="captionbig"><?=$version_star.get_cm_var('setcfg_plans_bandwith_counting_option')?></td>
        <td class="captionbig">
        <input type="radio" name="plan_bwcountSHA" value="0" onClick="planbwparamSHA('0')"><?=get_cm_var('setcfg_plans_disable_counting')?><br>
        <input type="radio" name="plan_bwcountSHA" value="1" onClick="planbwparamSHA('1')"><?=get_cm_var('setcfg_plans_enable_counting')?><br>
        <input type="radio" name="plan_bwcountSHA" value="2" onClick="planbwparamSHA('2')"><font id="bwcountSHA_color"><?=get_cm_var('setcfg_plans_enable_counting_and_quota')?></font>
        </td>
    </tr>
    <tr>
        <td class="captionbig"><?=get_cm_var('setcfg_plans_bandwidth_quota')?>&nbsp;</td>
        <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="plan_bwquota1SHA" id="plan_bwquota1SHA" maxlength="10" value="" style="width:100px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" onKeyPress="return numbersonly(this,event)"></td>
    </tr>	
	
	
<?php /**************************************************** Data transfer report reset ******************************************/ ?>

    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td valign="middle" class="captionbig"><?=get_cm_var('setcfg_plans_acc_bandwidth_reset_param')?></td>
        <td valign="top" class="captionbig">
        <input type="radio" name="plan_usr_abw_rm" value="0" onclick="plan_usr_abw_disable_all()"><?=get_cm_var('setcfg_users_quota_disable');?><input type="radio" name="plan_usr_abw_rm" value="1" onclick="plan_usr_abw_enable_textbox()"><?=get_cm_var('setcfg_users_monthly');?>
        <input type="radio" name="plan_usr_abw_rm" value="2" onclick="plan_usr_abw_disable_textbox()"><?=get_cm_var('setcfg_users_daily');?><input type="radio" name="plan_usr_abw_rm" value="3" onclick="plan_usr_abw_disable_all()"><?=get_cm_var('setcfg_users_quota_use_global_setting');?>
        </td>
    </tr>
<?php
    $plan_usr_resetabw_monthly_default = 'none';
    $plan_usr_resetabw_daily_default = 'none';

    $input = get_cm_var('setcfg_users_resetabw_monthly_str1').'
            <input type="text" name="plan_usr_abw_rdate" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)"  onfocus="this.select()">'.get_cm_var('setcfg_users_resetabw_monthly_str2').'
            <input type="text" name="plan_usr_abw_rp_1" maxlength="2" value="" class="shorttextbox" style="width:20px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.get_cm_var('setcfg_users_resetabw_monthly_str3');

    gen_invisible_line3(get_cm_var('setcfg_users_resetabw_title'),$input,'plan_usr_resetabw_monthly',$plan_usr_resetabw_monthly_default);

    $input = get_cm_var('setcfg_users_resetabw_daily_str1').'
            <input type="text" name="plan_usr_abw_rp_2" maxlength="3" value="" class="shorttextbox" style="width:30px;" onKeyPress="return numbersonly(this,event)" onfocus="this.select()">'.get_cm_var('setcfg_users_resetabw_daily_str2');

    gen_invisible_line3(get_cm_var('setcfg_users_resetabw_title'),$input,'plan_usr_resetabw_daily',$plan_usr_resetabw_daily_default);
?>

    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_users_print_quota')?>
        </td>
        <td class="captionbig">
            <input type="text" name="plan_printQuota" maxlength="6" class="shorttextbox" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>&nbsp;<?=get_cm_var('setcfg_users_pages_unit')?>
        </td>
    </tr>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_users_acl')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="plan_acl" value="y" disabled>
            <?=get_cm_var('setcfg_users_acl_y')?>
            <input type="radio" name="plan_acl" value="n" disabled checked>
            <?=get_cm_var('setcfg_users_acl_n')?>
        </td>
    </tr>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_users_rsu')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="plan_signup" value="y" disabled />
            <?=get_cm_var('setcfg_users_rsu_y')?>
            <input type="radio" name="plan_signup" value="n" disabled checked />
            <?=get_cm_var('setcfg_users_rsu_n')?>
        </td>
    </tr>
    <!-- MAC mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_mac_map_enabled')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="mac_map" value="y" disabled />
            <?=get_cm_var('setcfg_mac_map_yes')?>
            <input type="radio" name="mac_map" value="n" disabled checked />
            <?=get_cm_var('setcfg_mac_map_no')?>
        </td>
    </tr>
    <!-- IP mapping -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_ip_map_enabled')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="ip_map" value="y" disabled />
            <?=get_cm_var('setcfg_ip_map_yes')?>
            <input type="radio" name="ip_map" value="n" disabled checked />
            <?=get_cm_var('setcfg_ip_map_no')?>
        </td>
    </tr>
    <!-- Auto del -->
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr>
        <td class="captionbig">
            <?=get_cm_var('setcfg_auto_del_enabled')?>
        </td>
        <td class="captionbig">
            <input type="radio" name="plan_autodel" value="y" disabled checked />
            <?=get_cm_var('setcfg_auto_del_yes')?>
            <input type="radio" name="plan_autodel" value="n" disabled />
            <?=get_cm_var('setcfg_auto_del_no')?>
        </td>
    </tr>
    
    <tr>
        <td width="100%" colspan="2" valign="top" height="10">&nbsp;</td>
    </tr>
    <tr>
        <td colspan="2" align="center">
            <div id="saveCancel" style="display: none;">
                    <input type="submit" value="<?=get_cm_var('setcfg_plans_btn_save')?>" title="Save" class="graphicBtn">
                    <input type="button" value="<?=get_cm_var('setcfg_plans_btn_cancel')?>" title="Cancel" onClick="onCancel()" class="graphicBtn">
            </div>
        </td>
    </tr>
    <tr>
        <td width="100%" colspan="2" valign="top" height="10">&nbsp;</td>
    </tr>
    <input type="hidden" name="plan_session_handling" value="<?=$session_handling?>"> 
    </table>
    </form>

    </td>
    </tr>

    <tr>
        <td width="100%" colspan="5" valign="top" height="15"><img src="./images/blank.gif" border="0" width="3" height="15"></td>
    </tr>
