<?php
require_once 'secureLogin.php'; //prevent hacker run this script by setting GET variables
?>
<html>
<head>
<title>Free IP address</title>
<style type="text/css">
<!--
    ul { font-family: Tahoma, sans-serif; font-size: 10pt; }
    img { margin-right: 5px; border: 0; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    #display { color: #000; list-style: none; margin: 0px; padding: 0; }
    #add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    #display li, #add li { padding-left: 5px; }
    #display span, #add span { width: 220px; float:left; }
    form { margin: 0;}
-->
</style>
</head>
<body>

<?php

include 'display_list.php';

// 20080827 - Obtain information from config
$settingObj = new COM('FSCONFIG.Cfgmgr') or die('tableIP.php FSCONFIG.Cfgmgr Object cannot be created!');
$hostIpFile = $settingObj->getKey('hosts_ips_path', 'allowed hosts');
$settingObj = null;

// 20080827 - Replace hard-coded IP file
// register sessions, if needed
if (!isset($ser_displayIP)) { 
    $displayIP = new Saved_Array($hostIpFile);
    $ser_displayIP = serialize($displayIP);
    session_register("ser_displayIP");
}

if (!isset($ser_addIP)) {
  $addIP=new Site_Array;
  $ser_addIP=serialize($addIP);
  session_register("ser_addIP");
}

// unserialize data
if (isset($ser_displayIP)) {
    $displayIP=unserialize($ser_displayIP);
}
if (isset($ser_addIP)) {
    $addIP=unserialize($ser_addIP);
}

if ($displayIP->num_sites > 0) {
    echo '<ul id="display">';

    $i = 0;
    $class = '';

    while ($i < $displayIP->num_sites) {
        if ($displayIP->site_list[$i]->name != ';') {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($displayIP->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }
            echo '
    <li class="'.$class.'">
        <span><img src="./images/smallbubble.gif">'.$displayIP->site_list[$i]->name.'</span>
        <input type="checkbox" onclick="document.combo.item_noIP.value=\'dis'.$i.'\'; document.combo.submit();"'.$checked.'>
    </li>';
        }
        $i++;
    }

    echo "\n</ul>\n";
}

if ($addIP->num_sites > 0) {
    echo '<ul id="add">';

    $i = 0;
    $class = '';

    while ($i < $addIP->num_sites) {
        if ($addIP->site_list[$i]->name != ';') {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($addIP->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }
            echo '
    <li class="'.$class.'">
        <span><img src="./images/smallbubble.gif">'.$addIP->site_list[$i]->name.'</span>
        <input type="checkbox" onclick="document.combo.item_noIP.value=\'add'.$i.'\'; document.combo.submit();"'.$checked.'>
    </li>';
        }
        $i++;
    }

    echo "\n</ul>\n";
}

?>

<form name="combo" action="intermediate.php" method="post">
    <input type="hidden" name="item_noIP" value="">
</form>

</body>
</html>
