<?php
include_once "transaction.php";
$pending_release=false;

//initialize variable
$settingobj = new COM("FSCONFIG.Cfgmgr") or die("ppal_ipn2.php FSCONFIG.Cfgmgr Object cannot be created!");
$id=$settingobj->getKey( "id", "User_defined_payment");
$pin1=$settingobj->getKey( "pin1", "User_defined_payment");
$pin2=$settingobj->getKey( "pin2", "User_defined_payment");
$return=$settingobj->getKey( "ppal_return", "paypal");
// 20070831 - Correct typo
$cancel_return=$settingobj->getKey( "ppal_cancel_return", "paypal");
$notify_url=$settingobj->getKey( "notify_url", "User_defined_payment");
$currency_code=$settingobj->getKey( "currency", "User_defined_payment");  
//$settingobj->Release();
$settingobj=null;

//copy $_POST for validation
foreach ($_POST as $key => $val)
  $postfields[strtolower($key)] = $val;
    
$myTxn = new transaction();

$url_req = "cmd=_notify-validate&";
$url_req .= $myTxn->postfields_urlencode($_POST);

//postback to the payment gateway for validation (*)
$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen($url_req) . "\r\n\r\n";

$postback_url="www.sandbox.paypal.com";

$result = $myTxn->postback($postback_url, $header, $url_req, 120);


//check if require postfields are set or die
if (!isset($_POST["custom"])) {
  $log = date('l dS \of F Y h:i:s A')." - undefine invoice number.\r\n\r\n";
  $myTxn->writeLog("..\\log\\txn.log", $log);
  die;
}


//verify transaction (*)
if (strcmp ($result, "VERIFIED") == 0)
{ 
  $valid_txn = true;

  $log = "";
  if ( isset($_POST["txn_id"]) && $myTxn->isexist_transaction("txn_id", $_POST["txn_id"]) == true ) {
    $log .= date('l dS \of F Y h:i:s A')." - Transaction has been processed\r\n";
    $valid_txn = false;
  }

  if (isset($_POST["receiver_email"]) && strcmp ($_POST["receiver_email"], $id) != 0) {
    $log .= date('l dS \of F Y h:i:s A')." - Incorrect reciever_email\r\n";
    $valid_txn = false;
  }

  if (isset($_POST["mc_gross"]) && isset($_POST["mc_currency"]))
    if ($_POST["mc_gross"]!=$postfields['mc_gross'] && $_POST["mc_currency"]!=$postfields['mc_currency']) {
      $log .= date('l dS \of F Y h:i:s A')." - Incorrect mc_gross and mc_currency\r\n";
      $valid_txn = false;
    }

  if (isset($_POST["item_number"]) && isset($_POST["item_name"]))
    if ($_POST["item_number"]!=$postfields['item_number'] && $_POST["item_name"]!=$postfields['item_name']) {
      $log .= date('l dS \of F Y h:i:s A')." - Incorrect item_number and item_name\r\n";
      $valid_txn = false;
    }
  
  list($invoice_no, $username, $plan) = explode("|", $_POST["custom"]);
  if ( $myTxn->isexist_transaction("invoice", $invoice_no) != true ) {
    $log .= date('l dS \of F Y h:i:s A')." - invoice number not found\r\n";
    $valid_txn = false;
  }

  if ( $valid_txn == false ) {
    foreach ( $_POST as $key => $val )
      $log .= "$key = $val\r\n";
    $log .= "\r\n";
    $myTxn->writeLog("..\\log\\txn.log", $log);
  }
  
}
else
{ 
  $log = date('l dS \of F Y h:i:s A')." - Failed to Verify Transaction!\r\n";
  foreach ( $_POST as $key => $val )
    $log .= "$key = $val\r\n";
  $log .= "\r\n";  

  $myTxn->writeLog("..\\log\\txn.log", $log);
  
  die;
}


//update transaction table and user table (*)
if ($valid_txn == true)
{
  $txn_fields=array();

	// 20090708 - Add field type array
	$bFieldNumeric = array();

  if (isset($_POST["custom"]))
    list($invoice_no, $username, $plan) = explode("|", $_POST["custom"]);
  
	if (isset($_POST["payment_status"])) {
		$txn_fields['pay_status'] = $_POST["payment_status"];
		$bFieldNumeric['pay_status'] = 0;
	}
  
	if (isset($_POST["pending_reason"])) {
		$txn_fields['pendreason'] = $_POST["pending_reason"];
		$bFieldNumeric['pendreason'] = 0;
	}
  
	if (isset($_POST["payment_date"])) {
		$txn_fields['pay_date'] = $_POST["payment_date"];
		$bFieldNumeric['pay_date'] = 0;
	}

	if (isset($_POST["txn_id"])) {
		$txn_fields['txn_id'] = $_POST["txn_id"];
		$bFieldNumeric['txn_id'] = 0;
	}
  
	if (isset($_POST["payment_type"])) {
		$txn_fields['pay_type'] = $_POST["payment_type"];
		$bFieldNumeric['pay_type'] = 0;
	}
  
	if (isset($_POST["first_name"])) {
		$txn_fields['first_name'] = $_POST["first_name"];
		$bFieldNumeric['first_name'] = 0;
	}
  
	if (isset($_POST["last_name"])) {
		$txn_fields['last_name'] = $_POST["last_name"];
		$bFieldNumeric['last_name'] = 0;
	}
  
	if (isset($_POST["payer_email"])) {
		$txn_fields['payeremail'] = $_POST["payer_email"];
		$bFieldNumeric['payeremail'] = 0;
	}
  
	if (isset($_POST["payer_id"])) {
		$txn_fields['payer_id'] = $_POST["payer_id"];
		$bFieldNumeric['payer_id'] = 0;
	}
  
	if (isset($_POST["txn_type"])) {
		$txn_fields['txn_type'] = $_POST["txn_type"];
		$bFieldNumeric['txn_type'] = 0;
	}
  
	if (isset($_POST["subscr_date"])) {
		$txn_fields['subscrdate'] = $_POST["subscr_date"];
		$bFieldNumeric['subscrdate'] = 0;
	}
  
	if (isset($_POST["subscr_id"])) {
		$txn_fields['subscr_id'] = $_POST["subscr_id"];
		$bFieldNumeric['subscr_id'] = 0;
	}

  //handle your own postfields

    // 20071115 - Handle tax and shipping postfields issue
    // 20071114 - Set error flag
    // 20070807 - Validate if transacted amount matches with the plan
    //update transaction
    $payErrFlag = 0;
    $pureGross = 0;
    if (count($txn_fields) > 0) {
	if (isset($_POST["item_name"]) && isset($_POST["mc_gross"])) {
	    if (isset($_POST["tax"]) && $_POST["tax"] > 0) {
		$pureGross = $_POST["mc_gross"] - $_POST["tax"];
	    } else {
		$pureGross = $_POST["mc_gross"];
	    }
	    if (isset($_POST["shipping"]) && $_POST["shipping"] > 0) {
		$pureGross = $pureGross - $_POST["shipping"];
	    }
	    $vRC = $myTxn->ValidateCart($_POST["item_name"], $pureGross);
	    if ($vRC == -1) {
		$txn_fields['pay_status'] = "Failed";
				$bFieldNumeric['pay_status'] = 0;
		$payErrFlag = -2;
	    } elseif ($vRC == -2) {
		$txn_fields['pay_status'] = "Failed";
				$bFieldNumeric['pay_status'] = 0;
		$payErrFlag = -3;
	    }
	} else {
	    $txn_fields['pay_status'] = "Failed";
			$bFieldNumeric['pay_status'] = 0;
	    $payErrFlag = -1;
	}
	//$log = date('l dS \of F Y h:i:s A')." - ".$_POST["item_name"]." ".$_POST["mc_gross"]." ".$txn_fields["pay_status"]."\r\n";
	//$myTxn->writeLog("..\\log\\txn.log", $log);
		$myTxn->update_transaction($invoice_no, $txn_fields, $bFieldNumeric);
    }

    // 20071116 - Enhance log messages
    // 20070807 - Add condition and log message
    //update user credit
    if (isset($_POST["payment_status"]) && isset($_POST["txn_id"])) {
	if (strtolower($_POST["payment_status"]) == "completed" && strtolower($txn_field['pay_status']) != "failed") {
	    $myTxn->update_usr_table($username, $plan);
	    $log = date('l dS \of F Y h:i:s A')." - $username account has been updated!\r\n";
	} elseif (strtolower($_POST["payment_status"]) == "pending" && $pending_release==true && strtolower($txn_field['pay_status']) != "failed") {
	    $myTxn->update_usr_table($username, $plan);
	    $log = date('l dS \of F Y h:i:s A')." - $username account (released pending) has been updated!\r\n";
	} else {
	    if ($payErrFlag == -1) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to insufficient payment information!\r\n";
	    } elseif ($payErrFlag == -2) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to chosen shopping item does not exist!\r\n";
	    } elseif ($payErrFlag == -3) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to payment amount mismatch!\r\n";
	    } else {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account!\r\n";
	    }
	}
	$myTxn->writeLog("..\\log\\txn.log", $log);
    }

}
?>

<!--//redirect-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>FirstSpot&reg; | submit</title>
<link rel="stylesheet" href="local.css">
</head>
<body onLoad="redirect()">
<?php
// check is the transaction succeed (*)
if ( $valid_txn == true )
//if ( isset($_POST["x_response_code"]) && $_POST["x_response_code"] == "1" )
{
  $redirect_url=$return."?username=".$username;
  echo "<p>Transaction succeed!<br>";
  
}
else
{
  $redirect_url=$cancel_return."?username=".$username;
  echo "<p>Transaction failed!<br>";
  echo "Please contact the help desk!";
}
echo "<p>You will be redirected shortly.<br>";
echo "<a href='".$redirect_url."'>Click here to proceed</a>";
?>
</body>
<script type="text/javascript">
function redirect() {
  setTimeout("location.href=<?php echo "'".$redirect_url."'"; ?>", 1);
}
</script>
</html>
